//*************************************************************************************
// 	: SQ7653_ADC_LVCMP.h
// 汾		: V1.0 2020/07/17A
// 		: ADC ͷļ
// ע		: 
//**************************************************************************************

#ifndef _SQ7653_ADC_LVCMP_H__
#define _SQ7653_ADC_LVCMP_H__

/* ---------------------- extern ȫֱ ------------------------- */
extern unsigned char ADC_Int_Flag;	        // ADCжϷ
extern unsigned char ADCLVCMP_Int_Flag;	    // ADCϽײȽжϷ

/* ---------------------- Զ ------------------------------ */

#define ADC_RefScale(x)  (x/4096)           // xֵΪuV

#define IRFEN_VDD         0x01
#define IRFEN_XREF        0x02

#define AMD_Stop          0x00
#define	AMD_Single        0x01
#define AMD_Repeat        0x03

#define EVSEL_ADRS        0x00
#define EVSEL_TMRA00      0x08
#define EVSEL_TMRA01      0x09
#define EVSEL_TMRA30      0x0A
#define EVSEL_TMRA31      0x0C
#define EVSEL_EINT7       0x0D

#define CMP_Disable	      0x00
#define CMP_ADCLLV        0x01
#define CMP_ADCLLH        0x02
#define CMP_ADCL_BETWEEN  0x03

#define AIN0	       0x0
#define AIN1	       0x1
#define AIN2	       0x2
#define AIN3	       0x3
#define AIN4	       0x4
#define AIN5	       0x5
#define AIN6	       0x6
#define AIN7	       0x7

void ADC_Init();
void ADCLVLCMP_Init(unsigned char lvcmpsel);
void ADCLVLCMP_SetTh(uchar adcllv_Th,uchar adchlv_Th);
void ADC_Stop_and_Disable();
void ADC_IntEnable();
void ADC_IntDisable();
void ADCLVLCMP_IntEnable();

void ADC_Convert_Single();
char ADC_ConvertDone();
long ADC_Read_Value(unsigned char chsel);
void __interrupt ADC_IRQ(void);

#endif


