//*************************************************************************************
// 	: SQ7653_TMRA.h
// 汾		: V1.0 2020/07/17A
// 		: TMRA0 ͷļ 
// ע		:        
//**************************************************************************************
#ifndef _SQ7653_TMRA_H__
#define _SQ7653_TMRA_H__

/* ---------------------- extern ȫֱ ------------------------- */
extern unsigned char TMRA00_Int_Flag;	  	       // TMRA00жϷ
extern unsigned char TMRA01_Int_Flag;	  	       // TMRA01жϷ

/* ---------------------- Զ ------------------------------ */
//For t_mod_sel------
#define set_8bit    			0x00		       // 趨Ϊ 8λģʽ
#define	output  				0x01		       // 趨Ϊ ʱģʽ 
#define set_16bit  				0x02		       // 趨Ϊ 16λģʽ
#define pre_scale   			0x04		       // 趨Ϊ ԤȷƵģʽ
#define complementary   		0x05		       // 趨Ϊ ģʽ

//For op_mod_sel------
#define timer    				0x00		       // 趨Ϊ ʱģʽ
#define	event_counter  			0x01		       // 趨Ϊ ¼ģʽ 
#define capture  				0x03	  	       // 趨Ϊ ģʽ
#define pulse_width_modulation  0x04		       // 趨Ϊ PWMģʽ
#define pulse_width_measurement 0x05		       // 趨Ϊ ģʽ
#define PPG						0x06		       // 趨Ϊ ɳPPGģʽ

//----------------------------------------------------------------
void TMRA0_Timer_Init(unsigned char t_mode_sel); // TMRA0  ʱģʽʼ
void TMRA00_Init(unsigned char op_mode_sel);	   // TMRA00 ʱʼ
void TMRA01_Init(unsigned char op_mode_sel);	   // TMRA01 ʱʼ

void TMRA00_IntEnable();					       // TMRA00 жEnable
void TMRA01_IntEnable();					       // TMRA01 жEnable

void TMRA00_SetPeriod(unsigned int period);	   // ʱTMRA00 趨
void TMRA01_SetPeriod(unsigned int period);	   // ʱTMRA01 趨
void TMRA0_16bit_SetPeriod(unsigned int period); // 16λʱTMRA00+TMRA01 趨

void TMRA00_Start();							   // ʱTMRA00
void TMRA01_Start();							   // ʱTMRA01
void TMRA0_16bit_Start();						   // 16λʱTMRA00+TMRA01

void TMRA00_Stop();							 	   // ֹͣʱTMRA00
void TMRA01_Stop();							 	   // ֹͣʱTMRA01
void TMRA0_16bit_Stop();						   // ֹͣ16λʱTMRA00+TMRA01

void __interrupt TMRA00_IRQ(void);			  	   // TMRA00жӳ
void __interrupt TMRA01_IRQ(void);			  	   // TMRA01жӳ


#endif

