//*************************************************************************************
// 	: SQ7653_I2C_Master.c
// 汾		: V1.0 2020/07/17A
// 		: I2C ʹú (I2CƳ)
// ע		: I2C غ㼯ڱӳ	*趨I2C0ΪMaster mode
//**************************************************************************************
#include "main.h"

unsigned char I2C0_Init_SBI0CR1_Set_Value;

//*********************************************************************
// 	: I2C0_Init()
// 	: I2C0 ʼ
// ע		: I2C0 ùܽšģʽKI2C
//            [I2C0ΪMaster]
//*********************************************************************
void I2C0_Init(){
	
//====== I2C0ܽųʼ ======
//--SDA0 (P0.7) ; SCL0 (P0.6)-------
//  P0CFGCR֮[bit7]=1(д)[bit6:4]=(λ)[bit3:0]Datasheet֮PNIC½ڲ趨 λ

	P0CFGCR = 0xF3;  				    // P0.7趨ΪSDA0	1 111 0011
	P0CFGCR = 0xE3;					    // P0.6趨ΪSCL0	1 110 0011

//====== ܿ(Enable) ======
	PCKEN2_I2C0 = 1;                    // ȿݴò,I2C0 Enable

//====== 趨 ======
// SBI0CR2_SBIM = 1;

// 趨SBICR1_ACK=1,SBICR1_SCK=0x06λΪ0
// SBICR1_SCK=0x06@fsysclk=24MHzfsclԼΪ88 kHz
    SBI0CR1 = 0x16;  

/*	
	// SBI0CR1_ACK = 1;                 // Ӧģʽ(ACK enable)
	// SBI0CR1_BC = 0x00;               // (λ)9bit = 8bit + 1bit(ACK)
	// SBI0CR1_SCK = SCK_HI_135_LO_138; // ģʽƵʿ
*/
    
    
    //趨 SBI0CR2<MST> , <PIN> , <SBIM>
    SBI0CR2 = 0x18;						// 0001 1000
    
/*
	//SBI0CR2 = SBICR2_PIN|SBICR2_SBIM;
*/

	// IFR_I2C0_IRQ = 0;                // ж                      
	// IER_I2C0_IRQ = 0;                // I2C0 жϽ(Disable)

}


//SBI0CR2
//-----bit7 | bit6 | bit5 | bit4  |  bit3  | bit2 | bit1~bit0 ---------
//---  <MST>, <TRX>, <BB>, <PIN> and <SBIM>  <NA>   <SWRST>   ---------
//---  <MST>   1 : Master
//             0 : Slave
//---  <TRX>   1 :    ; 0: 
//---  <BB>    1 : ʼ
//             0 : ֹͣ
//---  <PIN>   1 : ȡжϷ
//
//---  <SBIM>  1 : Serial bus interface mode(ģʽ) / 0:Port mode
//---  <SWRST> ÿʼλ  
//----------------------------------------------------------------------	



//*********************************************************************
// 	: I2C0_IntEnable()
// 	: I2C0ж
// ע		: ִкῪж(IMF)**
//*********************************************************************
void I2C0_IntEnable(void){
	__ASM("DI");						// ֹпж
    
	IFR_I2C0_IRQ = 0;                   // ж
	IER_I2C0_IRQ = 1;	                // I2C0ж(Enable)
    
	__ASM("EI");						// пж
}


//*********************************************************************
// 	: I2C0_IntDisable() 
// 	: ֹI2C0ж
// ע		: ִкῪж(IMF)**
//*********************************************************************
void I2C0_IntDisable(void){
	__ASM("DI");						// ֹпж
    
	IFR_I2C0_IRQ = 0;                   // ж
	IER_I2C0_IRQ = 0;	                // I2C0жϽֹ
    
	__ASM("EI");						// пж	
}


//*********************************************************************
// 	: I2C_Start() [Master mode]
// 	: I2CStart
// ע		: 
//            adr : ͸Slaveװõλַ
//*********************************************************************
void I2C_Start(unsigned char adr){
    unsigned char tWait_I2C0 = 0;

	while( SBI0SR_BB == 1 ){}			// SBI0SR.BB: Bus status confirms is free ; 1 :busy  0: free

	SBI0CR1 = I2C0_Init_SBI0CR1_Set_Value;	// ***ÿһ I2C_Start趨SBI0CR1
    
    //****** Write data to the registers before the start condition is generated ******	
 	SBI0DBR = adr;						// 趨 Slave Device (ID)λַ
    
	SBI0CR2 = 0xf8;						// Write "1" to SBI0CR2<MST>, <TRX>, <BB>, <PIN>  and <SBIM>to "1"
										// 1111 1000
										// Set master,,ʼ,ȡжϷ  ģʽ
/*		
    // SBI0CR2 = SBICR2_MST|SBICR2_TX|SBICR2_BB|SBICR2_PIN|SBICR2_SBIM;
*/

	
 	while(SBI0SR_PIN){};             	// ȴͷжϣʾTXɣPINΪ0  @SBI0SR_PIN
 		
 	/*
	// ---յλcheck <LRB>ӦźACK---
		while(SBI0SR_LRB == 1){					
				tWait_I2C0++;			// Ӧ,  ==> SCKᱣ
				if(tWait_I2C0>250){		// Ӧѭ		
					I2C_Stop(i2c);		// I2C stop -> release SCK
					break;
				}	
		}
    */

	
}

//SBI0CR2
//-----bit7 | bit6 | bit5 | bit4  |  bit3  | bit2 | bit1~bit0 ---------
//---  <MST>, <TRX>, <BB>, <PIN> and <SBIM>  <NA>   <SWRST>   ---------
//---  <MST>   1 : Master
//             0 : Slave
//---  <TRX>   1 :    ; 0: 
//---  <BB>    1 : ʼ
//             0 : ֹͣ
//---  <PIN>   1 : ȡжϷ
//
//---  <SBIM>  1 : Serial bus interface mode(ģʽ) / 0:Port mode
//---  <SWRST> ÿʼλ  
//----------------------------------------------------------------------




//*********************************************************************
// 	: I2C_ReStart() [Master mode]
// 	: I2C ReStart
// ע		: 
//            adr : ͸Slaveװõλַ
//*********************************************************************
void I2C_ReStart(unsigned char adr){

	SBI0CR2 = 0x18;						// 0001 1000
										// Set master,,ʼ,ȡжϷ and ģʽ
/*                                        
	// SBI0CR2 = SBICR2_PIN|SBICR2_SBIM;
*/

	while(SBI0SR_BB == 1);				// SBI0SR_BB: Bus status confirms is free ; 1 :busy  0: free	
	while(SBI0SR_LRB == 0);				// wait <LRB>=1
	I2C_Start(adr);                 	// ͳ start + addressѶ

}


//SBI0CR2
//-----bit7 | bit6 | bit5 | bit4  |  bit3  | bit2 | bit1~bit0 ---------
//---  <MST>, <TRX>, <BB>, <PIN> and <SBIM>  <NA>   <SWRST>   ---------
//---  <MST>   1 : Master
//             0 : Slave
//---  <TRX>   1 :    ; 0: 
//---  <BB>    1 : ʼ
//             0 : ֹͣ
//---  <PIN>   1 : ȡжϷ
//
//---  <SBIM>  1 : Serial bus interface mode(ģʽ) / 0:Port mode
//---  <SWRST> ÿʼλ  
//---------------------------------------------------------------------- 



//*********************************************************************
// 	: I2C_Stop() [Master mode]
// 	: I2C Stop
// ע		: 
//*********************************************************************
void I2C_Stop(void){
	SBI0CR2 = 0xd8;			   			// Set SBI0CR2<MST>, <TRX> and <PIN> to "1" and SBI0CR2<BB> to "0"
										// 1101 1000
										// Set master,,ֹͣ,ȡжϷ and Portģʽ
/*
    // SBI0CR2 = SBICR2_MST|SBICR2_TX|SBICR2_PIN|SBICR2_SBIM;
*/

	while(SBI0SR_BB);              		// SBI0SR.BB: Bus status confirms is free ; 1 :busy  0: free
}


//*********************************************************************
// 	: I2C_TXOneByte() [Master mode]
// 	: I2C һByte
// ע		: 
//            TxBuf: 
//*********************************************************************
void I2C_TXOneByte(unsigned char TxBuf){
	SBI0DBR = TxBuf;
	SBI0CR2 = SBICR2_MST|SBICR2_TX|SBICR2_BB|SBICR2_PIN|SBICR2_SBIM;
	while(SBI0CR2_PIN);             	// ȴTX, PINΪ0


}


//*********************************************************************
// 	: I2C_RXOneByte() [Master mode]
// 	: I2C һByte
// ע		: 
//            return: ش
//*********************************************************************
unsigned char I2C_RXOneByte(){
	SBI0CR2 = SBICR2_MST|SBICR2_RX|SBICR2_BB|SBICR2_PIN|SBICR2_SBIM;
	SBI0DBR = 0x00;                 	// Buf

	while(SBI0CR2_PIN == 1);
	return SBI0DBR;					    // ش0ݻڵ
	
}




//*********************************************************************
// 	: I2C_AckEnable()
// 	: I2CǷһbitACKѶ
// ע		: 
//            enable : 1 
//				       0 ֹ
//*********************************************************************
void I2C_AckEnable(unsigned char enable){
	SBI0CR1_ACK = enable;				// I2C0 һbitACKѶ

}




//*********************************************************************
// 	: IsAck()
// 	: I2CǷACK
// ע		: 
//            return : 1 : NACK
//					   0 : ACK
//*********************************************************************
unsigned char IsAck(){
	if(SBI0SR_LRB ==0){
	return SBI0SR_LRB;
	
	}
	else {								// SBI0SR_LRB =1 NACK
	return I2C_NACK;
	}
	
	
}



//*********************************************************************
// 	: NACK_Stop_I2C()
// 	: I2CǷACKΪNACKI2C ִзStop,ش0
// ע		: 
//*********************************************************************
unsigned char NACK_Stop_I2C(){
	if(IsAck()==I2C_NACK){
	I2C_Stop();							// I2C ִзStop
	return 0;
	
	}
	

}



//*********************************************************************
// 	: I2C_BufCount()
// 	: I2Cbit
// ע		: 
//            bufcount : 
//                   BC_8bit      0x00
//                   BC_1bit      0x01
//                   BC_2bit      0x02
//                   BC_3bit      0x03
//                   BC_4bit      0x04
//                   BC_5bit      0x05
//                   BC_6bit      0x06
//                   BC_7bit      0x07 
//*********************************************************************
void I2C_BufCount(unsigned char bufcount){
	SBI0CR1_BC = bufcount;


}


//*********************************************************************
// 	: I2C_ReadState()
// 	: ȡI2C֮״̬
// ע		: 
//*********************************************************************
unsigned char I2C_ReadState(){
	return SBI0SR;						// ȡI2C0֮״̬


}


//*********************************************************************
// 	: I2C_SetBufvalue()
// 	: 趨I2C buffer
// ע		: 
//            data:  buffer
//*********************************************************************
void I2C_SetBufvalue(unsigned char data){
	SBI0DBR = data;


}



//*********************************************************************
// 	: I2C_ReadBufvalue()
// 	: I2C buffer
// ע		: 
//            return: buffer
//*********************************************************************
unsigned char I2C_ReadBufvalue(){
	return SBI0DBR;					// ش0ݻڵ


}



//*********************************************************************
// 	: I2C_Reset()
// 	: I2C software reset. SBI0CR1,I2C0AR,SBI0CR2 ,SBI0CR2<SBIM>
// ע		: λ
//*********************************************************************
void I2C_Reset(){
	SBI0CR2 = 0x1A;						// дSWRST[1:0]=0x02
	SBI0CR2 = 0x19;						// дSWRST[1:0]=0x01

}


//*********************************************************************
// 	: __interrupt I2C0_IRQ()
// 	: I2C0 жӳ
// ע		:
//*********************************************************************
void __interrupt I2C0_IRQ(void){
	__asm("NOP");						// ָ

}



//*********************************************************************
// 	: I2C_Master_Write()
// 	: 
// ע		: 
//*********************************************************************
unsigned char I2C_Master_Write(I2C_MasterPacket* pi2c){
unsigned char cnt;
	
	I2C_Start((unsigned char)(pi2c->adr<<1)|I2C_Write);
	NACK_Stop_I2C();					// ΪNACKI2C ִзStop
	
	I2C_TXOneByte(pi2c->cmd);			// I2C һByte
	NACK_Stop_I2C();					// ΪNACKI2C ִзStop

	
	for(cnt=0;cnt<pi2c->len;cnt++){
		I2C_TXOneByte(pi2c->buf[cnt]);  // I2C һByte
		
		NACK_Stop_I2C();				// ΪNACKI2C ִзStop
	}
	I2C_Stop();							// I2C ִзStop
	return 1;
}


//*********************************************************************
// 	: I2C_Master_Read()
// 	: 
// ע		: 
//*********************************************************************
unsigned char I2C_Master_Read(I2C_MasterPacket* pi2c){
unsigned char cnt;
	
	I2C_Start((unsigned char)(pi2c->adr<<1)|I2C_Write); // I2CStart
	NACK_Stop_I2C();							  // ΪNACKI2C ִзStop
	
	I2C_TXOneByte(pi2c->cmd);				  	  // I2C һByte (cmd)
	NACK_Stop_I2C();							  // ΪNACKI2C ִзStop

	I2C_ReStart((unsigned char)(pi2c->adr<<1)|I2C_Read);// I2C ReStart
	NACK_Stop_I2C();							  // ΪNACKI2C ִзStop

	
	for(cnt=0;cnt<pi2c->len;cnt++){
		if(cnt == pi2c->len-1){
			I2C_AckEnable(0);                 	  // ACK disable 
			I2C_BufCount(BC_8bit);            	  // 趨8bit
			pi2c->buf[cnt] = I2C_RXOneByte();
			I2C_BufCount(BC_1bit);            	  // 1bit ACK
			I2C_TXOneByte(0xFF);              	  // дNack dataΪ0xFF

			I2C_AckEnable(1);                 	  // ACK enable 
			I2C_BufCount(BC_8bit);            	  // 8bit
		}
		else{
    	pi2c->buf[cnt] = I2C_RXOneByte();     	  // 8bit+1bit ACK
		}		
	}
	I2C_Stop();								      // I2C ִзStop
	return 1;
}


