//SQ7653_SIO_Master_For_SPI_Flash_IS25LP080D
//*************************************************************************************
// 	: main.c
// 汾		: V1.0 2020/07/17A
// 		: 
// ˵	: ΪSQ7653 SIO0Master,SPI Flash IS25LP080DͨѶ
//			  IDE趨ϵ㣬ͨѶSector д롢ȡ֮
// ע		: ֮ӦѹΪ3.3VóSPI Flash IS25LP080D֮ѹջ
//            * ʹ÷MQ-Link磬ȷϵѹΪ"3.3V"Ϊ5V
//
// MSB ( bit7 ʼ),ѡ SIO ģʽ8 λͼģʽ,CPOL = 1, CPHA=1
// ע		: 1. SIO (ΪMaster) 
//			         (P3.6)ΪSCLK0
//		             (P4.0)ΪSI0
//					 (P3.7)ΪSO0
// 
//			  2. (P3.6)SCLK0----ӵ----IS25LP080D SCK0 ;    SCK
//				 (P4.0)SI0  ----ӵ----IS25LP080D SO   ;    MISO
//				 (P3.7)SO0  ----ӵ----IS25LP080D SI   ;    MOSI
//				 (P1.7)/CS  ----ӵ----IS25LP080D CE#  ;    /CSChip EN
//
// 				 (P1.7)/CS ģ⾧ƬPINslave ֻ /CS źΪ͵λʱ, Ŷ master ĲָзӦ[ҪʹLA SPI¼ƴ֮ʱ]
// 
//			  3. 
//				  [LED] LED 1  (P0.0) ȡManufacturerID & DeviceID ȷбƺ
//				  [LED] LED 2  (P0.1) Sector Erase ʱʹLED2һ
//				  [LED] LED 3  (P0.2) Page Program ʱLED3һ
//
//            4.  ȶԶֵȷLEDƵ
//                Data0~7ԶȡȷLED1~3
//                Data0~7жȡLED1~3 
//**************************************************************************************
#ifndef	IO_MEM
#define	IO_MEM
#endif

#include "main.h"

/* ----------------------  -------------------------- */
unsigned char Read_Data[16];
//unsigned char Send_Data[4];

unsigned char i,j;
unsigned char ManufacturerID_DATA = 0,DeviceID_DATA = 0;
/* -----------------------  --------------------------- */
void main()
{


/* ---------------------- ϵͳʼ ------------------------ */
//  ϵͳʱԭԤΪPLL 24MHz


/* ---------------------- ܽųʼ ------------------------ */
    P0OE  = 0x07;                        	  // 趨P0.0,P0.1,P0.2 ܽΪ

	P1OE_P7 = 1;							  // ģ/CS PIN,趨P1.7ܽΪ
	P1DO_P7 = 1;							  // ģ/CS PIN,ʼ趨P1.7ܽߵƽ

	LED1_out = 1;							  // ʼ趨LED1Ϊ״̬
	LED2_out = 1;							  // ʼ趨LED2Ϊ״̬
	LED3_out = 1;							  // ʼ趨LED3Ϊ״̬
/* ---------------------- SIO0ʼ ------------------------ */
    SIO0_Init();                        	  // SIO0ʼOMaster
	for(i=0;i<250;i++);                       // Delay loop

 //	 0x90 Ϊȡ Read Manufacturer ID:and Device ID 0x13 --------------------------------------------
    P1DO_P7 = 0;                              // /CS PIN Enable (͵ƽ)
	for(i=0;i<50;i++);
	SIO_ByteSend(0x90);                       // master TX 0x90 
	SIO_ByteSend(0x00);                       // 3 Dummy Bytes
	SIO_ByteSend(0x00);                  
	SIO_ByteSend(0x00);
	for(i=0;i<10;i++);						  // Delay loop
	
	ManufacturerID_DATA = SIO_ByteRead();     // master RX ȡManufacturer ID
	DeviceID_DATA = SIO_ByteRead();           // master RX ȡDevice ID
	
    P1DO_P7 = 1;	                          // /CS PIN Disable (ߵƽ)
	
	// ԤIS25LP080D ManufacturerID_DATAΪ0x9D  DeviceID_DATA Ϊ0x13
	// ȡȷLED1ȷLED1άֵ
	if(ManufacturerID_DATA == 0x9D && DeviceID_DATA == 0x13 ){                      
		LED1_out = 0;                         // ȷLED1
	}
	else{
		LED1_out = 1;                         // LED1
	}
    
    __asm("NOP");	                          // **ָϵ㴦ڴ˴**

 // *** ִ Sector Erase֮ǰִWrite Enable *** //
 //	 0x06 ΪWrite Enable: ------------------------------------------------
 	P1DO_P7 = 0;                              // /CS PIN Enable (͵ƽ)
 	SIO_ByteSend(0x06);                       // master TX 0x06 
    P1DO_P7 = 1;	                          // /CS PIN Disable (ߵƽ)  
	
	for(i=0;i<250;i++);
    
 //	 0x20 ΪSector Erase 4K-bytes ----------------------------------------
    
	P1DO_P7 = 0;                              // /CS PIN Enable (͵ƽ)
	SIO_ByteSend(0x20);                       // master TX 0x20 
	
    // Sector Erase [Sector 48] ʼλַΪ: 030000h
	SIO_ByteSend(0x03);                       // ADDR msb   A23 ~A16
	SIO_ByteSend(0x00);                       // ADDR       A15 ~A8 
	SIO_ByteSend(0x00);	                      // ADDR lsb   A7  ~A0
	P1DO_P7 = 1;                              // /CS PIN Disable (ߵƽ)
    for(i=0;i<250;i++);
	for(i=0;i<250;i++);
    IS25LP_WaitBusy();
    // Sector Erase Time (4K-bytes) wait>300 ms
    // Delay loop
	for(i=0;i<250;i++);                       // Delay loop
    for(i=0;i<250;i++);                       // Delay loop
    for(i=0;i<250;i++);                       // Delay loop
	
	LED2_out = 0;                             // LED2
	for(i=0;i<255;i++){                       // Delay loop
	   for(j=0;j<255;j++){
	   }
	}
	LED2_out = 1;                             // LED2
	
	__asm("NOP");	                          // **ָϵ㴦ڴ˴**
 // -------------------------------------------------------------------------------
 //	 0x03 Ϊȡ Slave Data: ------------------------------------------------
 // ոSector Erase 4K-bytesڶȡSlave Data 
 
    P1DO_P7 = 0;                              // /CS PIN Enable (͵ƽ)
	SIO_ByteSend(0x03);                       // master TX 0x03 
	// [Sector 48] ʼλַΪ: 030000h
	SIO_ByteSend(0x03);                       // ADDR msb   A23 ~A16
	SIO_ByteSend(0x00);                       // ADDR       A15 ~A8
	SIO_ByteSend(0x00);                       // ADDR lsb   A7  ~A0
	

	for(i=0;i<16;i++){
	Read_Data[i] = SIO_ByteRead();	          // SIO0
	
	}

    P1DO_P7 = 1;                              // /CS PIN Disable (ߵƽ)
	
    __asm("NOP");	                          // **ָϵ㴦ڴ˴**
	

 // *** ִ Page Program֮ǰִWrite Enable *** //
 //	 0x06 ΪWrite Enable: ------------------------------------------------  
 	P1DO_P7 = 0;                              // /CS PIN Enable (͵ƽ)
 	SIO_ByteSend(0x06);                       // master TX 0x06 
    P1DO_P7 = 1;	                          // /CS PIN Disable (ߵƽ) 
 
	for(i=0;i<250;i++);                       // Delay loop
    
 //	 0x02 Ϊд Slave Data: ---------------------------------------------
    P1DO_P7 = 0;	                          // /CS PIN Enable (͵ƽ)
	SIO_ByteSend(0x02);				          // Page Program (PP, 02h)
	// [Sector 48] ʼλַΪ: 030000h
	SIO_ByteSend(0x03);                       // ADDR msb   A23 ~A16
	SIO_ByteSend(0x00);                       // ADDR       A15 ~A8
	SIO_ByteSend(0x00);                       // ADDR lsb   A7  ~A0

    // Program Data0~Data7:0x76,0x53,0x1A,0x2B,0x3C,0x4D,0x5E,0x6F
	SIO_ByteSend(0x76);                       // PGM data 0
	SIO_ByteSend(0x53);                       // PGM data 1
	
	SIO_ByteSend(0x1A);                       // PGM data 2
	SIO_ByteSend(0x2B);                       // PGM data 3
	
	SIO_ByteSend(0x3C);                       // PGM data 4
	SIO_ByteSend(0x4D);                       // PGM data 5
	
	SIO_ByteSend(0x5E);                       // PGM data 6
	SIO_ByteSend(0x6F);                       // PGM data 7
	
	for(i=0;i<16;i++){
	Read_Data[i] = SIO_ByteRead();	          // SIO0
	
	}
    P1DO_P7 = 1;                              // /CS PIN Disable (ߵƽ) 
    for(i=0;i<250;i++);                       // Delay loop
    IS25LP_WaitBusy();        

	for(i=0;i<255;i++){                       // Delay loop
	   for(j=0;j<255;j++){
	   }
	}

    LED3_out = 0;                             // LED3
	for(i=0;i<255;i++){                       // Delay loop
	   for(j=0;j<255;j++){
	   }
	}   
    LED3_out = 1;                             // LED3
	
    __asm("NOP");	                          // **ָϵ㴦ڴ˴**
   

 //	 0x03 Ϊȡ Slave Data: ---------------------------------------------
 // ոPage ProgramڶȡSlave DataǷдSPI Flash
 
    P1DO_P7 = 0;                              // /CS PIN Enable (͵ƽ) 
	SIO_ByteSend(0x03);                       // master TX 0x03 
	// [Sector 48] ʼλַΪ: 030000h
	SIO_ByteSend(0x03);                       // ADDR msb   A23 ~A16
	SIO_ByteSend(0x00);                       // ADDR       A15 ~A8
	SIO_ByteSend(0x00);                       // ADDR lsb   A7  ~A0
	
	for(i=0;i<16;i++){
	Read_Data[i] = SIO_ByteRead();	          // SIO0
	
	}
	
    P1DO_P7 = 1;                              // /CS PIN Disable (ߵƽ) 
	
    // ȶԶֵȷLEDƵ
    if(Read_Data[0] == 0x76 &&
       Read_Data[1] == 0x53 &&
       Read_Data[2] == 0x1A &&
       Read_Data[3] == 0x2B &&
       Read_Data[4] == 0x3C &&
       Read_Data[5] == 0x4D &&
       Read_Data[6] == 0x5E &&
       Read_Data[7] == 0x6F
    ){  
		LED_all_turn_on;                      // ȷLED1~3
	}
	else{
		LED_all_turn_off;                     // LED1~3
	}
    
    
    __asm("NOP");	                          // **ָϵ㴦ڴ˴**


 
 while(1){  	
    CLR_WDT;                                  // Źʱ (ι)
    

    }
}




/* ---------------------- жϷ ------------------------ */
void __interrupt OnlyReti(void)
{
	__asm("NOP"); 							  // ָ
}

void __interrupt_n OnlyRetn(void)
{
	__asm("NOP");							  // ָ
}

void __interrupt_n WDT_IRQ(void)
{
	__asm("NOP");							  // ָ
}

void __interrupt_n SWI_IRQ(void)             // SWIλжϷ
{
	SWRST = 0x5a;
	SWRST = 0xa5;
	SWRST = 0xc3;
	SWRST = 0x3c;	
}
/* -------------------  жϷ ---------------------- */


/* -------------------- SQ7653ж ------------------ */
//  [ж] Ҫжид
//  1. ʹ֮߳жж֮OnlyRetiΪӦж
//  2. ӦڵַжƣֱӸ
//
//  ʹⲿж0ӦжϱеOnlyRetiΪEXT0_IRQ
//        EXT0_IRQ,    /* 0xffd6 : EXT0_IRQ      */      //ⲿж0
//--------------------------------------------------------------//
#pragma section const INT_VECTOR1
void * const IntTbl1[] = {
	OnlyReti,				/* 0xff3a : Reserved		  */									
	OnlyReti,				/* 0xff3c : Reserved		  */									
	OnlyReti,				/* 0xff3e : Reserved		  */									
	OnlyReti,				/* 0xff40 : Reserved		  */									
	OnlyReti,				/* 0xff42 : Reserved		  */									
	OnlyReti,				/* 0xff44 : Reserved		  */									
	OnlyReti,				/* 0xff46 : Reserved		  */								
	OnlyReti,				/* 0xff48 : Reserved		  */									
	OnlyReti,				/* 0xff4a : Reserved		  */									
	OnlyReti,				/* 0xff4c : Reserved		  */									
	OnlyReti,				/* 0xff4e : Reserved		  */									
	OnlyReti,				/* 0xff50 : Reserved		  */									
	OnlyReti,				/* 0xff52 : Reserved		  */									
	OnlyReti,				/* 0xff54 : Reserved		  */									
	OnlyReti,				/* 0xff56 : Reserved		  */									
	OnlyReti,				/* 0xff58 : Reserved		  */									
	OnlyReti,				/* 0xff5a : Reserved          */								
	OnlyReti,				/* 0xff5c : Reserved          */									
	OnlyReti,				/* 0xff5e : Reserved          */									
	OnlyReti,				/* 0xff60 : Reserved		  */									
	OnlyReti,				/* 0xff62 : Reserved		  */									
	OnlyReti,				/* 0xff64 : Reserved		  */									
	OnlyReti,				/* 0xff66 : Reserved		  */									
	OnlyReti,				/* 0xff68 : Reserved		  */									
	OnlyReti,				/* 0xff6a : Reserved    	  */
	OnlyReti,				/* 0xff6c : TX2_IRQ			  */	//жԴ:UART2 TX2								
	OnlyReti,				/* 0xff6e : RX2_IRQ			  */	//жԴ:UART2 RX2	
	OnlyReti,				/* 0xff70 : Reserved		  */									
	OnlyReti,				/* 0xff72 : Reserved		  */									
	OnlyReti,				/* 0xff74 : Reserved		  */									
	OnlyReti,				/* 0xff76 : Reserved		  */									
	OnlyReti,				/* 0xff78 : Reserved		  */									
	OnlyReti,				/* 0xff7a : Reserved		  */									
	OnlyReti,				/* 0xff7c : Reserved		  */									
	OnlyReti,				/* 0xff7e : Reserved		  */									
	OnlyReti,				/* 0xff80 : Reserved		  */		
	OnlyReti,		    	/* 0xff82 : EXT9_IRQ		  */	//ⲿж9							
	OnlyReti,	    		/* 0xff84 : EXT8_IRQ		  */	//ⲿж8								
	OnlyReti,				/* 0xff86 : Reserved		  */									
	OnlyReti,				/* 0xff88 : Reserved		  */									
	OnlyReti,				/* 0xff8a : Reserved		  */									
	OnlyReti,				/* 0xff8c : Reserved		  */									
	OnlyReti,				/* 0xff8e : Reserved		  */									
	OnlyReti,				/* 0xff90 : TX1_IRQ		      */	//жԴ:UART1 TX1						
	OnlyReti,				/* 0xff92 : RX1_IRQ		      */	//жԴ:UART1 RX1								
	OnlyReti,				/* 0xff94 : Reserved		  */									
	OnlyReti,				/* 0xff96 : Reserved		  */									
	OnlyReti,				/* 0xff98 : TMRA41_IRQ		  */	//жԴ:Timer A4counter1								
	OnlyReti,				/* 0xff9a : TMRA40_IRQ		  */	//жԴ:Timer A4counter0								
	OnlyReti,				/* 0xff9c : TMRA31_IRQ		  */	//жԴ:Timer A3counter1								
	OnlyReti,				/* 0xff9e : TMRA30_IRQ		  */	//жԴ:Timer A3counter0								
	OnlyReti,				/* 0xffa0 : EE_IRQ			  */	//жԴ:EEPROM						
	OnlyReti,				/* 0xffa2 : EXT7_IRQ		  */	//ⲿж7						
	OnlyReti,				/* 0xffa4 : EXT6_IRQ		  */	//ⲿж6								
	OnlyReti,				/* 0xffa6 : EXT5_IRQ		  */	//ⲿж5								
	OnlyReti,				/* 0xffa8 : EXT4_IRQ		  */	//ⲿж4								
	OnlyReti,				/* 0xffaa : Reserved		  */									
	OnlyReti,				/* 0xffac : Reserved		  */									
	OnlyReti,				/* 0xffae : Reserved		  */									
	OnlyReti,				/* 0xffb0 : DIC_IRQ			  */	//жԴ:DIC							
	OnlyReti,				/* 0xffb2 : Reserved		  */						
	OnlyReti,				/* 0xffb4 : Reserved		  */			
	OnlyReti,				/* 0xffb6 : Reserved		  */					
	OnlyReti,				/* 0xffb8 : Reserved		  */								
	OnlyReti,				/* 0xffba : Reserved		  */									
	OnlyReti,				/* 0xffbc : Reserved		  */									
	OnlyReti,				/* 0xffbe : Reserved		  */									
	OnlyReti,				/* 0xffc0 : Reserved		  */									
	OnlyReti,				/* 0xffc2 : Reserved		  */									
	OnlyReti,				/* 0xffc4 : FMC_IRQ			  */	//жԴ:FMC								
	OnlyReti,				/* 0xffc6 : Reserved		  */					
	OnlyReti,				/* 0xffc8 : CMP_IRQ  		  */	//жԴ:Ƚ								
	OnlyReti,				/* 0xffca : Reserved		  */									
	OnlyReti,				/* 0xffcc : Reserved		  */									
	OnlyReti,			    /* 0xffce : ADC_IRQ			  */	//жԴ:ADC								
	OnlyReti,				/* 0xffd0 : EXT3_IRQ		  */	//ⲿж3								
	OnlyReti,				/* 0xffd2 : EXT2_IRQ		  */	//ⲿж2							
	OnlyReti,				/* 0xffd4 : EXT1_IRQ		  */	//ⲿж1								
	OnlyReti,				/* 0xffd6 : EXT0_IRQ		  */	//ⲿж0								
	OnlyReti,				/* 0xffd8 : SIO0_IRQ		  */	//жԴ:SIO 0								
	OnlyReti,				/* 0xffda : I2C0_IRQ		  */	//жԴ:I2C 0								
	OnlyReti,				/* 0xffdc : TX0_IRQ			  */	//жԴ:UART0 TX0								
	OnlyReti,				/* 0xffde : RX0_IRQ			  */	//жԴ:UART0 RX0								
	OnlyReti,				/* 0xffe0 : Reserved		  */									
	OnlyReti,				/* 0xffe2 : TMRA21_IRQ		  */	//жԴ:Timer A2counter1					
	OnlyReti,				/* 0xffe4 : TMRA20_IRQ		  */	//жԴ:Timer A2counter0								
	OnlyReti,				/* 0xffe6 : TMRA11_IRQ		  */	//жԴ:Timer A1counter1								
	OnlyReti,				/* 0xffe8 : TMRA10_IRQ		  */	//жԴ:Timer A1counter0
	OnlyReti,				/* 0xffea : TMRA01_IRQ		  */	//жԴ:Timer A0counter1								
	OnlyReti,				/* 0xffec : TMRA00_IRQ		  */	//жԴ:Timer A0counter0								
	OnlyReti,			    /* 0xffee : LVD1_IRQ		  */	//жԴ:͵ѹLVD1
	OnlyReti, 			    /* 0xfff0 : TBT_IRQ			  */	//жԴ:ʱTBTʱ						
	OnlyReti,				/* 0xfff2 : Reserved		  */
	OnlyReti,				/* 0xfff4 : Reserved		  */
	OnlyReti,				/* 0xfff6 : LVD0_IRQ		  */	//жԴ:͵ѹLVD0							
	WDT_IRQ,				/* 0xfff8 : WDT_IRQ			  */	//non-maskable жԴ:Źʱ	
	(void *)0xffff,			/* 0xfffa : Reserved		  */		
	SWI_IRQ,				/* 0xfffc : SWI_IRQ/INTUNDEF  */	//non-maskable		
	STARTUP					/* 0xfffe : RESET		      */	//non-maskable			
};
#pragma section const
/* ------------------- Y SQ7653ж ---------------------- */

