//*************************************************************************************
// 	: SQ7653_TMRA4_Capture.c
// 汾		: V1.0 2020/07/17A
// 		: TMRA4_Captureʹú
// ע		: TMRA4_Capture غ㼯ڱӳ
//**************************************************************************************
#include "main.h"

unsigned char TMRA40_Int_Flag;		    // TMRA40жϷ
unsigned char TMRA41_Int_Flag;		  	// TMRA41жϷ

unsigned char Data_PWL,Data_PWH;			// תȡTMRA4PWMx
unsigned int  capture_value;				// ֵ֮
unsigned int  vRead_value1;
unsigned int  vRead_value2;
extern volatile unsigned int TMRA41_Int_count_value = 0;// TMRA41жϴֵΪ0


//*********************************************************************
// 	: TMRA40_8bit_Capture_Init()
// 	: TMRA40_8bit_ģʽʼ
// ע		: 
//*********************************************************************
void TMRA40_8bit_Capture_Init(){
//====== ܿ( Enable) ======
	PCKEN0_TMRA4 = 1;                   	// TMRA4ܿ( Enable)  *ȿݴò	

//====== 趨 ======

	//1.)---ģʽ趨->
	TMRA4CFG_TCFG = set_8bit;				// TMRA4Ϊ8λģʽ
	TMRA4MD0_TCM  = capture;    			// TMRA40趨Ϊģʽ
	
	// /ֹ˫
	TMRA4MD0_DBE   = 1;						// 1:  ˫Ĵ
	//TMRA4MD0_DBE = 0;						// 0: ֹ ˫Ĵ

	//2.)---趨ԴʱƵ->				
    // ϵͳƵΪ24MHz,TCA1֮ƵΪ23.437kHz
    TMRA4MD0_TCK = 0x01;                	// ʱTMRA40 Դʱӣfcgck/(2^10) = 24M/1024 Hz = 23.437kHz => λʱԼΪ42.6667us (0.0426ms)

	//3.)---ܽųʼ->
	//---Ѷ֮ܽ趨(P0.3)TA4G->
    //P0CFGCR֮[bit7]=1(д)[bit6:4]=(λ)[bit3:0]Datasheet֮PNIC½ڲ趨 λ
	P0CFGCR = 0xB4;  						// P0.3OTA4G	1 011 0100

	//4.)---ģʽѶشѡ->
	TMRA4CR1_EDGE = 0x00;					// 
	//TMRA4CR1_EDGE = 0x02;					// ½
	//TMRA4CR1_EDGE = 0x03;					// ½
	
}



//*********************************************************************
// 	: TMRA41_8bit_Capture_Init()
// 	: TMRA41_8bit_ģʽʼ
// ע		: 
//*********************************************************************
void TMRA41_8bit_Capture_Init(){
//====== ܿ( Enable) ======
	PCKEN0_TMRA4 = 1;                   	// TMRA4ܿ( Enable)  *ȿݴò	

//====== 趨 ======

	//1.)---ģʽ趨->
	TMRA4CFG_TCFG = set_8bit;				// TMRA4Ϊ8λģʽ
	TMRA4MD1_TCM  = capture;    			// TMRA41趨Ϊģʽ
	
	// /ֹ˫
	TMRA4MD1_DBE   = 1;						// 1:  ˫Ĵ
	//TMRA4MD1_DBE = 0;						// 0: ֹ ˫Ĵ

	//2.)---趨ԴʱƵ->				
    // ϵͳƵΪ24MHz,TCA1֮ƵΪ23.437kHz
    TMRA4MD1_TCK = 0x01;                	// ʱTMRA41 Դʱӣfcgck/(2^10) = 24M/1024 Hz = 23.437kHz => λʱԼΪ42.6667us (0.0426ms)

	//3.)---ܽųʼ->
	//---Ѷ֮ܽ趨(P0.3)TA4G->
    //P0CFGCR֮[bit7]=1(д)[bit6:4]=(λ)[bit3:0]Datasheet֮PNIC½ڲ趨 λ
	P0CFGCR = 0xB4;  						// P0.3OTA4G	1 011 0100

	//4.)---ģʽѶشѡ->
	TMRA4CR1_EDGE = 0x00;					// 
	//TMRA4CR1_EDGE = 0x02;					// ½
	//TMRA4CR1_EDGE = 0x03;					// ½
}



//*********************************************************************
// 	: TMRA4_16bit_Capture_Init()
// 	: TMRA4 16λģʽʼ
// ע		: 
//*********************************************************************
void TMRA4_16bit_Capture_Init(){
//====== ܿ( Enable) ======
	PCKEN0_TMRA4 = 1;                   	// TMRA4ܿ( Enable)  *ȿݴò	

//====== 趨 ======

	//1.)---ģʽ趨->
	TMRA4CFG_TCFG = set_16bit;				// TMRA4Ϊ16λģʽ
	TMRA4MD1_TCM  = capture;    			// TMRA41趨Ϊģʽ

	// /ֹ˫
	TMRA4MD1_DBE   = 1;					    // 1:  ˫Ĵ
	//TMRA4MD1_DBE = 0;						// 0: ֹ ˫Ĵ

	//2.)---趨ԴʱƵ->				
    // ϵͳƵΪ24MHz
	TMRA4MD1_TCK  = 0x00;					// ʱTMRA41Դʱѡ,A 2^11 (24M/2048=11.718KHz)λʱԼΪ0.0853ms

	//3.)---ܽųʼ->
	//---Ѷ֮ܽ趨(P0.3)TA4G->
    //P0CFGCR֮[bit7]=1(д)[bit6:4]=(λ)[bit3:0]Datasheet֮PNIC½ڲ趨 λ
	P0CFGCR = 0xB4;  						// P0.3OTA4G	1 011 0100

	//4.)---ģʽѶشѡ->
	TMRA4CR1_EDGE = 0x00;					// 
	//TMRA4CR1_EDGE = 0x02;					// ½
	//TMRA4CR1_EDGE = 0x03;					// ½
	
}



//*********************************************************************
// 	: TMRA40_IntEnable()
// 	: TMRA40ж (Enable)
// ע		: 
//*********************************************************************
void TMRA40_IntEnable(){
	__ASM("DI");					    	// ֹпж
	IER_TMRA40_IRQ = 1;                 	// TMRA40 ж
	
	//---жϿ->
	TMRA4CR0_EDGEIE = 1;					// ж
	
	//---λжϿ->
	//TMRA4CR0_TMROVIE = 1;             	// λʱTMRA40жҪ
	
	__ASM("EI");							// пж
}


//*********************************************************************
// 	: TMRA41_IntEnable()
// 	: TMRA41ж (Enable)
// ע		: 
//*********************************************************************
void TMRA41_IntEnable(){
	__ASM("DI");					    	// ֹпж
	IER_TMRA41_IRQ = 1;                 	// TMRA41 ж
	
	//---жϿ->
	TMRA4CR1_EDGEIE = 1;					// ж
	
	//---λжϿ->
	//TMRA4CR1_TMROVIE = 1;             	// λʱTMRA41жҪ
	
	__ASM("EI");							// пж
}



//*********************************************************************
// 	: TMRA40_IntDisable()
// 	: TMRA40жϽֹ (Disable)
// ע		: 
//*********************************************************************
void TMRA40_IntDisable(){
	__ASM("DI");					    	// ֹпж
	IER_TMRA40_IRQ = 0;                 	// TMRA40 жϽֹ
	
	//---жϿ->
	//TMRA4CR0_EDGEIE = 0;					// ֹж
	
	//---λжϿ->
	//TMRA4CR0_TMROVIE = 0;             	// λʱTMRA40жҪ
	
	__ASM("EI");							// пж
}


//*********************************************************************
// 	: TMRA41_IntDisable()
// 	: TMRA41жϽֹ (Disable)
// ע		: 
//*********************************************************************
void TMRA41_IntDisable(){
	__ASM("DI");					    	// ֹпж
	IER_TMRA41_IRQ = 0;                 	// TMRA41 жϽֹ
	
	//---жϿ->
	//TMRA4CR1_EDGEIE = 0;					// ֹж
	
	//---λжϿ->
	//TMRA4CR1_TMROVIE = 0;             	// λʱTMRA41жҪ
	
	__ASM("EI");							// пж
}



//*********************************************************************
// 	: TMRA40_Start()
// 	: ʱTMRA40
// ע		: 
//*********************************************************************
void TMRA40_Start(){
	TMRA4CR0_RUN = 1;                   	// TMRA40ʼ
	
}


//*********************************************************************
// 	: TMRA41_Start()
// 	: ʱTMRA41
// ע		: 
//*********************************************************************
void TMRA41_Start(){
	TMRA4CR1_RUN = 1;                   	// TMRA41ʼ
	
}


//*********************************************************************
// 	: TMRA4_16bit_Start()
// 	: 16λʱTMRA40+TMRA41
// ע		: 
//*********************************************************************
void TMRA4_16bit_Start(){
	TMRA4CR1_RUN = 1;                   	// 16λʱ
	
}


//*********************************************************************
// 	: TMRA40_Stop()
// 	: ֹͣʱTMRA40
// ע		: 
//*********************************************************************
void TMRA40_Stop(){
	TMRA4CR0_RUN = 0;                   	// TMRA40ֹͣʱ
	IFR_TMRA40_IRQ = 0;						// TMRA40_IRQжϱ
}


//*********************************************************************
// 	: TMRA41_Stop()
// 	: ֹͣʱTMRA41
// ע		: 
//*********************************************************************
void TMRA41_Stop(){
	TMRA4CR1_RUN = 0;                   	// TMRA41ֹͣʱ
	IFR_TMRA41_IRQ = 0;						// TMRA41_IRQжϱ



}


//*********************************************************************
// 	: TMRA4_16bit_Stop()
// 	: ֹͣ16λʱTMRA40+TMRA41
// ע		: 
//*********************************************************************
void TMRA4_16bit_Stop(){
	TMRA4CR1_RUN = 0;                   	// ֹͣ16λʱ
	IFR_TMRA41_IRQ = 0;						// TMRA41_IRQжϱ
}


//*********************************************************************
// 	: TMRA4_16bit_Read_Capture_Value()
// 	: ȡ16λTMRA40+TMRA41ֵ
// ע		: *16λģʽ
//*********************************************************************
unsigned int TMRA4_16bit_Read_Capture_Value(){
	Data_PWL = TMRA4PWM0;						// ȶȡλԪ(L-Byte,8bit)
	Data_PWH = TMRA4PWM1;						// ȶȡλԪ(H-Byte,8bit)
	
	capture_value = ((Data_PWH<<8) | Data_PWL); // ֵ֮ϸߵλԪΪ16bit
	return capture_value;
}


//*********************************************************************
// 	: __interrupt TMRA40_IRQ()
// 	: TMRA40жӳ
// ע		:
//*********************************************************************
void __interrupt TMRA40_IRQ(void){
	__asm("NOP");							// ָ

	
}


//*********************************************************************
// 	: __interrupt TMRA41_IRQ()
// 	: TMRA41жӳ
// ע		:
//*********************************************************************
void __interrupt TMRA41_IRQ(void){
	__asm("NOP");							// ָ
	TMRA41_Int_count_value++;				// TMRA41жϴֵ1
	IER_TMRA41_IRQ = 0;						// Disable the interrupt

	if(TMRA41_Int_count_value==1){
		vRead_value1 = TMRA4_16bit_Read_Capture_Value();	//read value1 ȡ16λTMRA40+TMRA41ֵ

	}
	else if(TMRA41_Int_count_value==2){	// ڶνTMRA41ж	
		TMRA41_Int_Flag = 1;				// TMRA41жϷ趨Ϊ1
		vRead_value2 = TMRA4_16bit_Read_Capture_Value();	//read value2 ȡ16λTMRA40+TMRA41ֵ
	
		TMRA41_Int_count_value = 0;			//  TMRA41жϴֵ
	}
IFR_TMRA41_IRQ = 0;							// TMRA41_IRQжϱ	
IER_TMRA41_IRQ = 1; 						// enable the interrupt


}


