//*************************************************************************************
// 	: SQ7653_ADC_LVCMP.c
// 汾		: V1.0 2020/07/17A
// 		: ADC_LVCMP ʹú (ADC_LVCMPƳ)
// ע		: ADC_LVCMP غ㼯ڱӳ
//*************************************************************************************

#include "main.h"

unsigned char ADC_Int_Flag;			      // ADCжϷ
unsigned char ADCLVCMP_Int_Flag =0;	          // ADCϽײȽжϷ

unsigned char r_tempData[2];
long ain7_value;                       		  // ȡAIN7ADCֵ
long ain7_mv;                          		  // ADC value תɵѹֵ(λmv)

//*********************************************************************
// 	: ADC_Init()
// 	: ADCʼ
// ע		: 
//*********************************************************************
void ADC_Init(){
    
//=== ADCܽųʼ (ѡAD תģźͨ)===
// P1CFGCR֮[bit7]=1(д)[bit6:4]=(λ)[bit3:0]Datasheet֮PNIC½ڲ趨 λ
// SQ7653 AIN0~AIN7 8ܽſʹ---
// PINC ѡ

	//--- AIN0 ---//	
	//P1CFGCR = 0x8F;                     // P1.0ΪAIN0 1 000 1111
    
	//--- AIN1 ---//	
    //P1CFGCR = 0x9F;                     // P1.1ΪAIN1 1 001 1111

	//--- AIN2 ---//	
	//P1CFGCR = 0xAF;                     // P1.2ΪAIN2 1 010 1111
	
	//--- AIN3 ---//	
	//P1CFGCR = 0xBF;                     // P1.3ΪAIN3 1 011 1111

	//--- AIN4 ---//	                  
	//P1CFGCR = 0xCF;                     // P1.4ΪAIN4 1 100 1111 

	//--- AIN5 ---//	
    //P1CFGCR = 0xDF;                     // P1.5ΪAIN5 1 101 1111
	
	//--- AIN6 ---//	
    //P1CFGCR = 0xEF;                     // P1.6ΪAIN6 1 110 1111
	
	//--- AIN7 ---//[ѡܽ]	
	P1CFGCR = 0xFF;                       // P1.7ΪAIN7 1 111 1111
   
//====== ܿ(Enable) ======          // ȿݴò
	PCKEN6_ADC = 1;                       // 趨Χ·ʱADCĴ enable ADC peripheral clock 

//====== 趨 ======
// 趨ADC (Set ADC Convert Speed)
    ADCCKDIV_ADCKDIV = 2;	              // fsysclk/(2^2)

// ADEN趨ADCClock Warm upuser趨ADCSR_ADRSʼִADת.
	ADCCR0_ADEN  = 1;                     // ADC
	ADCCR0_IRFEN = 0x01;                  // Set VrefʹVDDAοѹ
    //ADCCR0_INTLV  = 1;                  // ж趨ȫAINɨɲŷж

	ADCCR0_AUTOPD = 0;                    // ADCÿתԶ
    
// 趨ADCģʽ
    ADCCR0_AMD   = 0x01;                  // ģʽ

// ADC ݻԶд
    //ADCSR_BUFOVR = 1;                   // ADC ݻԶд

// ¼趨	
	ADCCR1_EVSEL = 0x00;                  // ¼趨ΪADCת
	
// źͨɨ
	ADCSCAN0 = 0x80;                      // 趨ADC ɨͨ:AIN7

}

//*********************************************************************
// 	: ADCLVLCMP_Init()
// 	: ADCײȽϳʼ
// ע		: 
// 
// lvcmpsel : CMP_Disable	       0x0   // ײȽϽֹ
//            CMP_ADCLLV           0x1   // ADC ֵ < ADCLLV             ** CMP ADCLLV ** 
//            CMP_ADCLLH           0x2   // ADC ֵ > ADCHLV             ** CMP ADCHLV ** 
//            CMP_ADCL_BETWEEN     0x3   // ADCLLV > ADC ֵ > ADCHLV    ** CMP ADCLLV and ADCHLV **
//*********************************************************************
void ADCLVLCMP_Init(unsigned char lvcmpsel){
    
    ADCLV_LVCMP  = lvcmpsel;             // ײȽ,߽ױȽ(ADC ֵ > ADCHLV)
    
    //ADCLV_LVINTVL = 0;    			 // ԽнײȽ 
	ADCLV_LVINTVL = 1;    				 // LVSEL ָͨнײȽ   
	ADCLV_LVSEL   = 7;                   // ָADC ͨ:AIN7нײȽ


}



//*********************************************************************
// 	: ADCLVLCMP_SetTh()
// 	: ADCײȽżֵ趨 (0~4095,0x0000~0x0FFF)
//
// ע		: adcllv_Th : 趨ADCײȽż
//            adchlv_Th : 趨ADCײȽż
//*********************************************************************
void ADCLVLCMP_SetTh(uchar adcllv_Th,uchar adchlv_Th){
/*
	ADCLLV = 0xFA0;
	ADCHLV = 0x3E8;
*/ 

    ADCLLV = 4000;          // if ADC < ADCLLV, then ADCSR_LVDET = 1
	ADCHLV = 1000;          // if ADC > ADCHLV, then ADCSR_LVDET = 1

}


//*********************************************************************
// 	: ADC_Stop_and_Disable()
// 	: ADCתֹǿֹͣAD 
// ע		: 
//*********************************************************************
void ADC_Stop_and_Disable()
{
	ADCCR0_AMD  = 0;                      // תֹǿֹͣAD 
    ADCCR0_ADEN = 0;                      // ADCֹ    
}


//*********************************************************************
// 	: ADC_IntEnable()
// 	: ADCж
// ע		: 
//*********************************************************************
void ADC_IntEnable(){
	__ASM("DI");

	IER_ADC_IRQ = 1;                     // ADC ж
	ADCCR0_INTEN = 1;                    // ADC ж
	
	__ASM("EI");
}


//*********************************************************************
// 	: ADC_IntDisable()
// 	: ֹADCж
// ע		: 
//*********************************************************************
void ADC_IntDisable(){
	__ASM("DI");

	IER_ADC_IRQ  = 0;                     // ADC жϽ
	IFR_ADC_IRQ  = 0;	                  // Disable IRQ
	ADCCR0_INTEN = 0;                     // ADC жϽֹ ,Disable source EOCF
	
	__ASM("EI");
}



//*********************************************************************
// 	: ADCLVLCMP_IntEnable()
// 	: ADCײȽж
// ע		: 
//*********************************************************************
void ADCLVLCMP_IntEnable(){
    __ASM("DI");
    
    IER_ADC_IRQ = 1;                      // ADC ж
    ADCCR2_LVINTEN = 1;                   // ײȽж, Enable source Level detected
    
    __ASM("EI");
}



//*********************************************************************
// 	: ADC_Convert_Single()
// 	: ADC Single modeת
// ע		: 
//*********************************************************************
void ADC_Convert_Single(){
	while(!ADCSR_ADRDY);                  // ȴADC
	ADCSR_ADRS = 1;                       // ADCתʼ
	

}



//*********************************************************************
// 	: ADC_ConvertDone()
// 	: ADCת
// ע		: 
//*********************************************************************
char ADC_ConvertDone(){
	if(ADCSR_EOCF){
		return 1;                         // ADCתɣش1
	}
	else{
		return 0;                         // ֮ADCתδɣش0
	}
}



//*********************************************************************
// 	: ADC_Read_Value()
// 	: ADCֵ
// ע		: chsel :ѡһAIN,趨£ 
//                   AIN0	       0x0
//                   AIN1	       0x1
//                   AIN2	       0x2
//                   AIN3	       0x3
//                   AIN4	       0x4
//                   AIN5	       0x5
//                   AIN6	       0x6
//                   AIN7	       0x7
//*********************************************************************
long ADC_Read_Value(unsigned char chsel){
	unsigned int adc_value = 0;
	
	ADCCHSEL = chsel;                     // ѡADCͨ

    r_tempData[0] = ADCDRL;               // ADCֵ,ȶLow Byte,ٶHigh Byte
    r_tempData[1] = ADCDRH;

	adc_value |= r_tempData[0];                  
	adc_value |= (unsigned int)r_tempData[1]<<8;
	return (long)adc_value;
}


//*********************************************************************
// 	: __interrupt ADC_IRQ()
// 	: ADC жӳ
// ע		:
//*********************************************************************
void __interrupt ADC_IRQ(void){
	__asm("NOP");                         // ָ
    
	
	for(i=0;i<6000;i++);
	
	//--- ADCϽײȽ,ײжϷ ---
	if (ADCSR_LVDET){			          // ⵽ϽײȽ,жϷ
		ADCLVCMP_Int_Flag = 1;			  // ϽײȽжϷ趨Ϊ1        
        ADCSR_EOCF = 1;		              // ADCת
        ADCSR_LVDET = 1;	              // clean flag
		
        ain7_value = ADC_Read_Value(AIN7);  			   // ȡAIN7ADCֵ
	    ain7_mv = ain7_value*ADC_RefScale(3090000)/1000;   // ADCֵתɵѹֵ(λ:mV)
/*
		ADCCHSEL_CHSEL = 7;	              // set Ain7 and then read ADCDRL and ADCDRH
        r_tempData[0] = ADCDRL;	          // read Low and then High
		r_tempData[1] = ADCDRH;	          // read Low and then High
*/       


 
		LED1_out = ~LED1_out;             // LED1 (LED1 (P0.0))
		__asm("NOP");                     // ָ
		__asm("NOP");                     // ָ,ɽbreak point趨ڴ

     }


	//--- ADCתж ---
/*
	if (ADCSR_EOCF){			          // ADCת,жϷ
		ADC_Int_Flag = 1;				  // ADCжϷ趨Ϊ1
        ADCSR_EOCF = 1;		              // ADCת
	}
*/	



}


