//******************************************
//  : SQ7653_TMRA_Complementary
// 汾     : V 1.00 2019/12/12 SQ7653
//      : TMRA0 Complementary ʹú
// ע     :
//******************************************
#ifndef _SQ7653_TMRA_Complementary_H__
#define _SQ7653_TMRA_Complementary_H__

/******************
 * 1st Argument
 * ****************/
/* ---------------------- Զ ------------------------------ */
//For t_mod_sel------
#define set_8bit    			0x00		    // 趨Ϊ 8λģʽ
#define output  				0x01		    // 趨Ϊ ʱģʽ 
#define set_16bit  			    0x02		    // 趨Ϊ 16λģʽ
#define pre_scale   			0x04		    // 趨Ϊ ԤȷƵģʽ
#define complementary   		0x05		    // 趨Ϊ ģʽ

//For op_mod_sel------
#define timer    				0x00		    // 趨Ϊ ʱģʽ
#define event_counter  		    0x01		    // 趨Ϊ ¼ģʽ 
#define capture  				0x03	  	    // 趨Ϊ ģʽ
#define PWM  					0x04		    // 趨Ϊ PWMģʽ
#define pulse_measure 		    0x05		    // 趨Ϊ ģʽ
#define PPG						0x06		    // 趨Ϊ ɳPPGģʽ

extern unsigned char TMRA00_Int_Flag;		  	// TMRA00жϷ
extern unsigned char TMRA01_Int_Flag;		  	// TMRA01жϷ

void TMRA00_Timer_Init(void);
void TMRA0_16BIT_Complementary_Init(void);
void TMRA1_16BIT_Complementary_Init(uchar CP_mode);
//====================
void TMRA0_16BIT_SetDuty(uint duty);
void TMRA0_16BIT_SetPeriod(uint period);
//======================
void TMRA0_SetDeadTime(uchar scale, uchar Dtime);
void TMRA0_Fault_Detect_Init(uchar FD_mode);
//======================

void TMRA00_Start(void);
void TMRA01_Start(void);
void TMRA11_Start(void);
void TMRA00_Stop(void); 
void TMRA01_Stop(void);
void TMRA11_Stop(void);

void TMRA00_IntEnable(void);
void TMRA01_IntEnable(void);
void TMRA00_IntDisable(void);
void TMRA01_IntDisable(void);

void __interrupt TMRA00_IRQ(void);
void __interrupt TMRA01_IRQ(void);
void __interrupt TMRA11_IRQ(void);


#endif








