//SQ7653_I2C0_Master_EEPROM_24C08
//*************************************************************************************
// 	: main.c
// 汾		: V1.1 (Sep. 4, 20)
// 		: 
// ˵	: 24C08 R/W 
//			  IDE趨ϵ㣬ͨѶͬд뼰ȡEEPROM_24C08֮
// ע		: 
//			  1. (P0.7)SDA0----ӵ----24C08 SDA Pin
//				 (P0.6)SCL0----ӵ----24C08 SCL Pin
//	             *[ע]SDA,SCLⲿ
//            2.
//				 [LED] LED 1  (P0.0)
//				 [LED] LED 2  (P0.1)
//				 [LED] LED 3  (P0.2)
//
//            3. Write Sequence ʱLED1~3õ(ܹ۲쵽LEDƻһ)
//**************************************************************************************
#ifndef	IO_MEM
#define	IO_MEM
#endif
#include "main.h"

/* ----------------------  -------------------------- */
unsigned char      iloop;
unsigned char      wBuf[16];    // ʹдSlave֮
unsigned char      rBuf[16];    // ôSlaveնȡ֮

// Ϊ˷չʾ鿴д16 0xFFEEPROM
unsigned char      wBufFF[] = {0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF,
							     0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF};

/* -----------------------  --------------------------- */
void main()
{
/* ---------------------- ϵͳʼ ------------------------ */
//  ϵͳʱԤΪPLL 24MHz
	Delay_Loop_Init();                       // ʱȦʼ
                                             // (ʹSQ7653_Delay_Loop.cʱȦ)

/* ---------------------- ܽųʼ ------------------------ */
    P0OE  = 0x07;                            // 趨P0.0,P0.1,P0.2 ܽΪ
    P1OE  = 0x00;                            // 趨P1.0,P1.1,P1.2 ܽΪ
	P1PU |= 0x07;                       	 // 趨P1.0,P1.1,P1.2 

	LED1_to_LED3_turn_off;                   // ʼ趨LED1~3Ϊ״̬
/* ---------------------------------------------------------- */
	// 趨16ʵ write buffer data
    for( iloop=0; iloop<16; iloop++ ){
        wBuf[iloop]  = 0x10+iloop;
	}
/* ---------------------- I2C0ܳʼ ------------------------ */ 
    I2C0_Init();							 // I2C, 8λֽ , Ack , ģʽ							
//----------------------------------------------------------------

  // * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * //
  //  Master Operation                                                         //
  // * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * //

    // Write Sequence FF
    // Ϊ˷չʾ鿴д16 0xFFEEPROM

        LED1_to_LED3_turn_on;                     // 趨LED1~3Ϊ
        delay_ms(100);
	
        I2C0_Start(0xa0, 0x00);			          // Ϊģʽʼʹ1ֽ(1byte)(0x00)   
        //..........| 0xa0: 趨 slave Device ID (AT24C08 EEPROM)
        //................| 0x00: 趨 slave start address
        
        // Slave֮0x00λÿʼд16ݣд֮ΪwBufFF[]
        I2C0_Bytes_Write(wBufFF, 16); 	
        I2C0_Stop();						      // ֹͣ
	
        delay_ms(6);                              // ȴ AT24C08A pgm time >5ms...
 
	    LED1_to_LED3_turn_off;                    // 趨LED1~3Ϊ
        __asm("NOP");					          // ָ,IDE趨ϵ㴦

    //-------------------------------------------------------------------------------------
	//  Read Sequence
    //  0x00ʼһвŵrBuf
    	
		I2C0_Start(0xa0, 0x00);			          // Ϊģʽʼʹ1ֽ(1byte)(0x00)    
		//..........| 0xa0: 趨 slave Device ID (AT24C08 EEPROM)
        //................| 0x00: 趨 slave start address
        
        I2C0_ReStart(0xa0);          	          // ظʼ
	
		// Slave֮0x00λÿʼ16ݣȡյݷŵrBuf[]
		I2C0_Bytes_Read(rBuf, 16);
		I2C0_Stop();						      // ֹͣ
		
		__asm("NOP");				              // ָ
		__asm("NOP");				              
		__asm("NOP");				              
		__asm("NOP");				              
		__asm("NOP");					          // ָ,IDE趨ϵ㴦

 	//-------------------------------------------------------------------------------------
    //  Write Sequence
    //  0x00ʼдһwBuf
  
        LED1_to_LED3_turn_on;                     // 趨LED1~3Ϊ
        delay_ms(100);
		I2C0_Start(0xa0, 0x00);			          // Ϊģʽʼʹ1ֽ(1byte)(0x00)      
		//..........| 0xa0: 趨 slave Device ID (AT24C08 EEPROM)
        //................| 0x00: 趨 slave start address

	    // Slave֮0x00λÿʼд3ݣд֮ΪwBuf[]
		I2C0_Bytes_Write(wBuf, 3);     	          
		I2C0_Stop();						      // ֹͣ
		
        delay_ms(6);                              // ȴ AT24C08A pgm time >5ms...
		
		LED1_to_LED3_turn_off;                    // 趨LED1~3Ϊ 
		__asm("NOP");					          // ָ,IDE趨ϵ㴦
	
	//-------------------------------------------------------------------------------------
    //  Read Sequence
    //  0x00ʼһвŵrBuf

		I2C0_Start(0xa0, 0x00);			          // Ϊģʽʼʹ1ֽ(1byte)(0x00)     
		//..........| 0xa0: 趨 slave Device ID (AT24C08 EEPROM)
        //................| 0x00: 趨 slave start address		
        
        I2C0_ReStart(0xa0);          	          // ظʼ
		
		// Slave֮0x00λÿʼ10ݣȡյݷŵrBuf[]
		I2C0_Bytes_Read(rBuf, 10);
		I2C0_Stop();						      // ֹͣ
		
		__asm("NOP");					          // ָ
		__asm("NOP");
		__asm("NOP");
		__asm("NOP");
		__asm("NOP");					          // ָ,IDE趨ϵ㴦

	//-------------------------------------------------------------------------------------
    //  Write Sequence
    //  0x06ʼдһwBuf
    
		LED1_to_LED3_turn_on;                     // 趨LED1~3Ϊ
        delay_ms(100);

		I2C0_Start(0xa0, 0x06);			          // Ϊģʽʼʹ1ֽ(1byte)(0x06)     
		//..........| 0xa0: 趨 slave Device ID (AT24C08 EEPROM)
        //................| 0x06: 趨 slave start address
	
	    // Slave֮0x06λÿʼд2ݣд֮ΪwBuf[]
		I2C0_Bytes_Write(wBuf, 2);
		I2C0_Stop();						      // ֹͣ

        delay_ms(6);                              // ȴ AT24C08A pgm time >5ms...
	
		LED1_to_LED3_turn_off;                    // 趨LED1~3Ϊ
		__asm("NOP");					          // ָ,IDE趨ϵ㴦

	//-------------------------------------------------------------------------------------
    //  Read Sequence
    //  0x00ʼһвŵrBuf
    
		I2C0_Start(0xa0, 0x00);			          // Ϊģʽʼʹ1ֽ(1byte)(0x00)      
		//..........| 0xa0: 趨 slave Device ID (AT24C08 EEPROM)
        //................| 0x00: 趨 slave start address		
        
        I2C0_ReStart(0xa0);          	          // ظʼ
		
		// Slave֮0x00λÿʼ10ݣȡյݷŵrBuf[]
		I2C0_Bytes_Read(rBuf, 10);
		I2C0_Stop();                              // ֹͣ
		__asm("NOP");					          // ָ,IDE趨ϵ㴦
		

	//-------------------------------------------------------------------------------------
    //  Read Sequence
    //  0x05ʼһвŵrBuf

        I2C0_Start(0xa0, 0x05);			          // Ϊģʽʼʹ1ֽ(1byte)(0x05)   
		//..........| 0xa0: 趨 slave Device ID (AT24C08 EEPROM)
        //................| 0x05: 趨 slave start address        
        
        I2C0_ReStart(0xa0);          	          // ظʼ
        
        // Slave֮0x05λÿʼ10ݣȡյݷŵrBuf[]
        I2C0_Bytes_Read(rBuf, 10);
        I2C0_Stop();                              // ֹͣ
        __asm("NOP");					          // ָ,IDE趨ϵ㴦

	//-------------------------------------------------------------------------------------
 
    while(1){
        CLR_WDT;						          // Źʱ (ι)
    }



}


/* ---------------------- жϷ ------------------------ */
void __interrupt OnlyReti(void)
{
	__asm("NOP"); 							  // ָ
}

void __interrupt_n OnlyRetn(void)
{
	__asm("NOP");							  // ָ
}

void __interrupt_n WDT_IRQ(void)
{
	__asm("NOP");							  // ָ
}

void __interrupt_n SWI_IRQ(void)              // SWIλжϷ
{
	SWRST = 0x5a;
	SWRST = 0xa5;
	SWRST = 0xc3;
	SWRST = 0x3c;	
}
/* -------------------  жϷ ---------------------- */


/* -------------------- SQ7653ж ------------------ */
//  [ж] Ҫжид
//  1. ʹ֮߳жж֮OnlyRetiΪӦж
//  2. ӦڵַжƣֱӸ
//
//  ʹⲿж0ӦжϱеOnlyRetiΪEXT0_IRQ
//        EXT0_IRQ,    /* 0xffd6 : EXT0_IRQ      */      //ⲿж0
//--------------------------------------------------------------//
#pragma section const INT_VECTOR1 
void * const IntTbl1[] = {
	OnlyReti,				/* 0xff3a : Reserved		  */									
	OnlyReti,				/* 0xff3c : Reserved		  */									
	OnlyReti,				/* 0xff3e : Reserved		  */									
	OnlyReti,				/* 0xff40 : Reserved		  */									
	OnlyReti,				/* 0xff42 : Reserved		  */									
	OnlyReti,				/* 0xff44 : Reserved		  */									
	OnlyReti,				/* 0xff46 : Reserved		  */								
	OnlyReti,				/* 0xff48 : Reserved		  */									
	OnlyReti,				/* 0xff4a : Reserved		  */									
	OnlyReti,				/* 0xff4c : Reserved		  */									
	OnlyReti,				/* 0xff4e : Reserved		  */									
	OnlyReti,				/* 0xff50 : Reserved		  */									
	OnlyReti,				/* 0xff52 : Reserved		  */									
	OnlyReti,				/* 0xff54 : Reserved		  */									
	OnlyReti,				/* 0xff56 : Reserved		  */									
	OnlyReti,				/* 0xff58 : Reserved		  */									
	OnlyReti,				/* 0xff5a : Reserved          */								
	OnlyReti,				/* 0xff5c : Reserved          */									
	OnlyReti,				/* 0xff5e : Reserved          */									
	OnlyReti,				/* 0xff60 : Reserved		  */									
	OnlyReti,				/* 0xff62 : Reserved		  */									
	OnlyReti,				/* 0xff64 : Reserved		  */									
	OnlyReti,				/* 0xff66 : Reserved		  */									
	OnlyReti,				/* 0xff68 : Reserved		  */									
	OnlyReti,				/* 0xff6a : Reserved    	  */
	OnlyReti,				/* 0xff6c : TX2_IRQ			  */	//жԴ:UART2 TX2								
	OnlyReti,				/* 0xff6e : RX2_IRQ			  */	//жԴ:UART2 RX2	
	OnlyReti,				/* 0xff70 : Reserved		  */									
	OnlyReti,				/* 0xff72 : Reserved		  */									
	OnlyReti,				/* 0xff74 : Reserved		  */									
	OnlyReti,				/* 0xff76 : Reserved		  */									
	OnlyReti,				/* 0xff78 : Reserved		  */									
	OnlyReti,				/* 0xff7a : Reserved		  */									
	OnlyReti,				/* 0xff7c : Reserved		  */									
	OnlyReti,				/* 0xff7e : Reserved		  */									
	OnlyReti,				/* 0xff80 : Reserved		  */		
	OnlyReti,		    	/* 0xff82 : EXT9_IRQ		  */	//ⲿж9							
	OnlyReti,	    		/* 0xff84 : EXT8_IRQ		  */	//ⲿж8								
	OnlyReti,				/* 0xff86 : Reserved		  */									
	OnlyReti,				/* 0xff88 : Reserved		  */									
	OnlyReti,				/* 0xff8a : Reserved		  */									
	OnlyReti,				/* 0xff8c : Reserved		  */									
	OnlyReti,				/* 0xff8e : Reserved		  */									
	OnlyReti,				/* 0xff90 : TX1_IRQ		      */	//жԴ:UART1 TX1						
	OnlyReti,				/* 0xff92 : RX1_IRQ		      */	//жԴ:UART1 RX1								
	OnlyReti,				/* 0xff94 : Reserved		  */									
	OnlyReti,				/* 0xff96 : Reserved		  */									
	OnlyReti,				/* 0xff98 : TMRA41_IRQ		  */	//жԴ:Timer A4counter1								
	OnlyReti,				/* 0xff9a : TMRA40_IRQ		  */	//жԴ:Timer A4counter0								
	OnlyReti,				/* 0xff9c : TMRA31_IRQ		  */	//жԴ:Timer A3counter1								
	OnlyReti,				/* 0xff9e : TMRA30_IRQ		  */	//жԴ:Timer A3counter0								
	OnlyReti,				/* 0xffa0 : EE_IRQ			  */	//жԴ:EEPROM						
	OnlyReti,				/* 0xffa2 : EXT7_IRQ		  */	//ⲿж7						
	OnlyReti,				/* 0xffa4 : EXT6_IRQ		  */	//ⲿж6								
	OnlyReti,				/* 0xffa6 : EXT5_IRQ		  */	//ⲿж5								
	OnlyReti,				/* 0xffa8 : EXT4_IRQ		  */	//ⲿж4								
	OnlyReti,				/* 0xffaa : Reserved		  */									
	OnlyReti,				/* 0xffac : Reserved		  */									
	OnlyReti,				/* 0xffae : Reserved		  */									
	OnlyReti,				/* 0xffb0 : DIC_IRQ			  */	//жԴ:DIC							
	OnlyReti,				/* 0xffb2 : Reserved		  */						
	OnlyReti,				/* 0xffb4 : Reserved		  */			
	OnlyReti,				/* 0xffb6 : Reserved		  */					
	OnlyReti,				/* 0xffb8 : Reserved		  */								
	OnlyReti,				/* 0xffba : Reserved		  */									
	OnlyReti,				/* 0xffbc : Reserved		  */									
	OnlyReti,				/* 0xffbe : Reserved		  */									
	OnlyReti,				/* 0xffc0 : Reserved		  */									
	OnlyReti,				/* 0xffc2 : Reserved		  */									
	OnlyReti,				/* 0xffc4 : FMC_IRQ			  */	//жԴ:FMC								
	OnlyReti,				/* 0xffc6 : Reserved		  */					
	OnlyReti,				/* 0xffc8 : CMP_IRQ  		  */	//жԴ:Ƚ								
	OnlyReti,				/* 0xffca : Reserved		  */									
	OnlyReti,				/* 0xffcc : Reserved		  */									
	OnlyReti,			    /* 0xffce : ADC_IRQ			  */	//жԴ:ADC								
	OnlyReti,				/* 0xffd0 : EXT3_IRQ		  */	//ⲿж3								
	OnlyReti,				/* 0xffd2 : EXT2_IRQ		  */	//ⲿж2							
	OnlyReti,				/* 0xffd4 : EXT1_IRQ		  */	//ⲿж1								
	OnlyReti,				/* 0xffd6 : EXT0_IRQ		  */	//ⲿж0								
	OnlyReti,				/* 0xffd8 : SIO0_IRQ		  */	//жԴ:SIO 0								
	OnlyReti,				/* 0xffda : I2C0_IRQ		  */	//жԴ:I2C 0								
	OnlyReti,				/* 0xffdc : TX0_IRQ			  */	//жԴ:UART0 TX0								
	OnlyReti,				/* 0xffde : RX0_IRQ			  */	//жԴ:UART0 RX0								
	OnlyReti,				/* 0xffe0 : Reserved		  */									
	OnlyReti,				/* 0xffe2 : TMRA21_IRQ		  */	//жԴ:Timer A2counter1					
	OnlyReti,				/* 0xffe4 : TMRA20_IRQ		  */	//жԴ:Timer A2counter0								
	OnlyReti,				/* 0xffe6 : TMRA11_IRQ		  */	//жԴ:Timer A1counter1								
	OnlyReti,				/* 0xffe8 : TMRA10_IRQ		  */	//жԴ:Timer A1counter0
	OnlyReti,				/* 0xffea : TMRA01_IRQ		  */	//жԴ:Timer A0counter1								
	OnlyReti,				/* 0xffec : TMRA00_IRQ		  */	//жԴ:Timer A0counter0								
	OnlyReti,			    /* 0xffee : LVD1_IRQ		  */	//жԴ:͵ѹLVD1
	OnlyReti, 			    /* 0xfff0 : TBT_IRQ			  */	//жԴ:ʱTBTʱ						
	OnlyReti,				/* 0xfff2 : Reserved		  */
	OnlyReti,				/* 0xfff4 : Reserved		  */
	OnlyReti,				/* 0xfff6 : LVD0_IRQ		  */	//жԴ:͵ѹLVD0							
	WDT_IRQ,				/* 0xfff8 : WDT_IRQ			  */	//non-maskable жԴ:Źʱ	
	(void *)0xffff,			/* 0xfffa : Reserved		  */		
	SWI_IRQ,				/* 0xfffc : SWI_IRQ/INTUNDEF  */	//non-maskable		
	STARTUP					/* 0xfffe : RESET		      */	//non-maskable			
};
#pragma section const
/* ------------------- Y SQ7653ж ---------------------- */

