//******************************************
//  : SQ7653_TMRA0
// 汾     : V 1.00 2019/12/18 SQ7653
//      : TMRA0(TMRA00+TMRA01)ʹú
// ע     :
//******************************************

#include "main.h"


//*********************************************************************
//    : TMRA00_Timer_Init
//  : TMRA00 8λrģʽr 16.7us
// ע     :
//*********************************************************************
void TMRA00_Timer_Init(void)
{
//====== ܿ( Enable) ======
    PCKEN0_TMRA0 = 1;                   // ȿݴò
   	
//====== 趨 ======
    TMRA0CFG_TCFG   = set_8bit;         // 趨Ϊ 8 bit ģʽ
    TMRA0MD0_TCM    = timer;            // 趨Ϊ 8 λʱģʽ
    TMRA0MD0_TCK    = 5;                // fcgck/4 = 6MHz = 0.167us
    TMRA0MD0_DBE    = 1;                // ʹ˫
    
    TMRA0DR0        = 100;              // 趨ֵ: ÿ 100 * 0.167us жһ (ֵ=TMRA0DR0*TMRA0MD0_TCK)
}

//*********************************************************************
//    : TMRA00_PPG_Init
//  : TMRA00 8λPPGģʽL16.7usռձ50%
// ע     :
//*********************************************************************
void TMRA00_PPG_Init(void)
{
//====== ܽųʼ ======
    P0DO_P5         = 1;                // ܽʼ P05ߵƽ  **ͬ PPG ĳʼֵ(TMRAxMOD_TFF)
    P0OE_P5         = 1;                // P05ܽ趨Ϊ

//====== ܿ( Enable) ======
    PCKEN0_TMRA0    = 1;                // ȿݴò

//====== 趨 ======
    TMRA0CFG_TCFG   = set_8bit;         // 趨Ϊ 8 bit ģʽ
    TMRA0MD0_TCM    = PPG;              // 趨Ϊ 8 λɱ PPG ģʽ
	
    TMRA0MD0_TFF    = 1;                // 趨ʼֵΪ"׼λ"ռձ
//	***PxCFGCR ùţڳʼֵ趨֮ PxCFGCR
    P0CFGCR         = 0xD1;             // лP05Ϊ⹦ܽ,ܽ趨Ϊ PPG 
    
    TMRA0MD0_TCK    = 5;                // fcgck/4 = 6MHz = 0.167us
    TMRA0MD0_DBE    = 1;                // ʹ˫

    TMRA0DR0        = 100;              // 趨 PPG  = 16.7us   (PPG=TMRA0DR0*TMRA0MD0_TCK)
    TMRA0PWM0       = 50;               // 趨 PPG ռձ = 50/100 = 50%
}

//*********************************************************************
//    : TMRA00_PWM_Init
//  : TMRA00 8λPWMģʽDuty=128ռձ50%
// ע     :
//*********************************************************************
void TMRA00_PWM_Init(void)
{
//====== ܽųʼ ======
    P0DO_P5         = 1;                // ܽʼ P05ߵƽ  **ͬ PPG ĳʼֵ(TMRAxMOD_TFF)
    P0OE_P5         = 1;                // P05ܽ趨Ϊ

//====== ܿ( Enable) ======
    PCKEN0_TMRA0    = 1;                // ȿݴò

//====== 趨 ======
    TMRA0CFG_TCFG   = set_8bit;         // 趨Ϊ 8 bit ģʽ
    TMRA0MD0_TCM    = PWM;              // 趨Ϊ 8 λɱ PWM ģʽ
	
    TMRA0MD0_TFF    = 1;                // 趨ʼֵΪ"׼λ"ռձ	
//	***PxCFGCR ùţڳʼֵ趨֮ PxCFGCR
    P0CFGCR         = 0xD1;             // лP05Ϊ⹦ܽ,ܽ趨Ϊ PWM 

    TMRA0MD0_TCK    = 5;                // fcgck/4 = 6MHz = 0.167us
    TMRA0MD0_DBE    = 1;                // ʹ˫

// ***ʹ PWM ʱ()̶Ϊ 255TMRA0DR0 趨
// 128 * 0.167us = 21.376us (ڕrgL)
    TMRA0PWM0       = 128;              // (128/2)/128 = 50%A2019/0125()
	

}


//*********************************************************************
//    : TMRA00_ECounter_Init
//  : TMRA00 8λ¼ģʽ(Event Counter)
// ע     :
//*********************************************************************
void TMRA00_ECounter_Init(void)
{
//==== ܿ( Enable) ======
    PCKEN0_TMRA0 = 1;                   // ȿݴò

//====== 趨 ======
    TMRA0CFG_TCFG   = set_8bit;         // 趨Ϊ 8 bit ģʽ
    TMRA0MD0_TCM    = event_counter;    // 趨Ϊ 8 λģʽ
    TMRA0MD0_DBE    = 1;                // ʹ˫
	TMRA0DR0        = 250;              // 趨ֵ

	P0CFGCR         = 0xD1;             // лP05Ϊ⹦ܽ,ܽ趨Ϊ Event Counter λ
    
}

//*********************************************************************
//    : TMRA0_12BIT_PWM_Init
//  : TMRA0 12λģʽLڹ̶ֵռձ170.625 /256=66.7%
// ע     :
//*********************************************************************
void TMRA0_12BIT_PWM_Init(void)
{
//====== ܽųʼ ======
    P0DO_P4         = 1;                // ܽʼ P04ߵƽ  **ͬ PPG ĳʼֵ(TMRAxMOD_TFF)
    P0OE_P4         = 1;                // P04ܽ趨Ϊ

//====== ܿ( Enable) ======
    PCKEN0_TMRA0    = 1;                // ȿݴò

//====== 趨 ======
    TMRA0CFG_TCFG   = set_16bit;        // 趨Ϊ 16it ģʽ
    TMRA0MD1_TCM    = PWM;                // 趨Ϊ 12λɱ PWM ģʽ

    TMRA0MD1_TFF    = 1;                // 趨ʼֵΪ"׼λ"ռձ
   
    TMRA0MD1_TCK    = 5;                // fcgck/4 = 6MHz = 0.167us
    TMRA0MD1_DBE    = 1;                // ʹ˫
	
	TMRA0PWM0       = 0xAA;             // 趨 PWM ռձ
    TMRA0PWM1       = 0xA;              // 趨 PWM ռձ  =>(2730/16) Oռձ P 170.625 /256 = 66.7%
	//	***PxCFGCR ùţڳʼֵ趨֮ PxCFGCR
	P0CFGCR         = 0xC1;             // лP04Ϊ⹦ܽ,ܽ趨Ϊ PWM 
}


//*********************************************************************
//    : TMRA0_16BIT_ECounter_Init
//  : TMRA00 16λ¼ģʽ(Event Counter)
// ע     :
//*********************************************************************
void TMRA0_16BIT_ECounter_Init(void)
{
//==== ܿ( Enable) ======
    PCKEN0_TMRA0 = 1;                   // ȿݴò

//====== 趨 ======
    TMRA0CFG_TCFG   = set_16bit;        // 趨Ϊ 16 bit ģʽ
    TMRA0MD1_TCM    = event_counter;    // 趨Ϊ 16 λʱģʽ
   	
	TMRA0MD1_DBE    = 1;                // ʹ˫
	TMRA0DR0        = 100;              // 趨ֵ
    TMRA0DR1        = 2;                // 趨ֵ
	P0CFGCR         = 0xD1;             // лP05Ϊ⹦ܽ,ܽ趨Ϊ Event Counter λ
    
}

//*********************************************************************
//    : TMRA0_16BIT_PPG_Init
//  : TMRA0 16λģʽPPGʼֵ趨ռձ80%
// ע     :
//*********************************************************************
void TMRA0_16BIT_PPG_Init(void)
{
//====== ܽųʼ ======
    P0DO_P4         = 1;                // ܽʼ P04ߵƽ  **ͬ PPG ĳʼֵ(TMRAxMOD_TFF)
    P0OE_P4         = 1;                // P04ܽ趨Ϊ

//====== ܿ( Enable) ======
    PCKEN0_TMRA0    = 1;                // ȿݴò

//====== 趨 ======
    TMRA0CFG_TCFG   = set_16bit;        // 趨Ϊ 16it ģʽ
    TMRA0MD1_TCM    = PPG;              // 趨Ϊ 16λɱ PPG ģʽ
	
    TMRA0MD1_TFF    = 1;                // 趨ʼֵΪ"׼λ"ռձ
//	***PxCFGCR ùţڳʼֵ趨֮ PxCFGCR
    P0CFGCR         = 0xC1;             // лP04Ϊ⹦ܽ,ܽ趨Ϊ PPG 
    
    TMRA0MD1_TCK    = 5;                // fcgck/4 = 6MHz = 0.167us
    TMRA0MD1_DBE    = 1;                // ʹ˫

    TMRA0DR0        = 50;           	// 趨 PPG =(100*256+50)=25650(PPG=TMRA0DR0*TMRA0MD0_TCK)
    TMRA0DR1        = 100;
	
	TMRA0PWM0       = 40;               // 趨 PPG ռձ=(80*256+40)=20520, 20520/25650=80%
    TMRA0PWM1       = 80;             
}

//*********************************************************************
//    : TMRA0_Prescale_PPG_Init
//  : ô̬ Prescale+PPG
// ע     : ռձ趨 : TMRA0PWM1/TMRA0DR1   (8λPPGģʽ)
//                       : TMRA0PWM0/TMRA0DR0   (8λPrescaleģʽ)
//*********************************************************************
void TMRA0_Prescale_PPG_Init(void)
{
	//====== ܽųʼ ======
    P0DO_P4         = 1;                // ܽʼ P04ߵƽ  **ͬ PPG ĳʼֵ(TMRAxMOD_TFF)
    P0OE_P4         = 1;                // P04ܽ趨Ϊ

//====== ܿ( Enable) ======
    PCKEN0_TMRA0    = 1;                // ȿݴò

//====== 趨 ======
    TMRA0CFG_TCFG   = pre_scale;        // 趨Ϊ Prescale ģʽ
	TMRA0MD0_TCM    = PPG;              // 趨Ϊ 8+8 λɱ Prescale+PPG ģʽ
    TMRA0MD1_TCM    = PPG;              // 趨Ϊ 8+8 λɱ Prescale+PPG ģʽ
	
	TMRA0MD0_TFF    = 1;                // 趨ʼֵΪ"׼λ" prescaler module  Duty
    TMRA0MD1_TFF    = 1;                // 趨ʼֵΪ"׼λ" PPG module  Duty
    
    TMRA0MD0_TCK    = 5;                // fcgck/4 = 6MHz = 0.167us
	TMRA0MD0_DBE    = 1;                // ʹ˫
    TMRA0MD1_DBE    = 1;                // ʹ˫

    TMRA0PWM0       = 5;                // 趨 Prescale ռձ = (5/10)= 50%=> prescale Ƶ (fSYSCLK/4)/Cycle 
    TMRA0DR0        = 10;           	 
    
	TMRA0PWM1       = 80;               // 趨 PPG ռձ 80/100 = 80% 
	TMRA0DR1        = 100;
	//	***PxCFGCR ùţڳʼֵ趨֮ PxCFGCR
    P0CFGCR         = 0xC1;             // лP04Ϊ⹦ܽ,ܽ趨Ϊ PPG λ
	//P0CFGCR         = 0xD1;             // лP05Ϊ⹦ܽ,ܽ趨Ϊ Prescale λ
}

//*********************************************************************
//    : TMRA00_SetDuty
//  : }(Duty)ֵ
// ע     : ռձ : TMRA0PWM0 (8λԪģʽ)
//*********************************************************************
void TMRA00_SetDuty(uchar duty)
{
    TMRA0PWM0      = duty;
}

//*********************************************************************
//    : TMRA00_SetPeriod
//  : L(Cycle)ֵ
// ע     : TMRA0DR0 (8λԪģʽ)
//*********************************************************************
void TMRA00_SetPeriod(uchar period)
{
    TMRA0DR0       = period;
}

//*********************************************************************
//    : TMRA01_SetDuty
//  : }ֵ
// ע     : ռձ : TMRA0PWM1 (8λԪģʽ)
//*********************************************************************
void TMRA01_SetDuty(uchar duty)
{
    TMRA0PWM1     = duty;
}

//*********************************************************************
//    : TMRA01_SetPeriod
//  : Lڼֵ
// ע     : TMRA0DR1 (8λԪģʽ)
//*********************************************************************
void TMRA01_SetPeriod(uchar period)
{
    TMRA0DR1      = period;
}


//*********************************************************************
//    : TMRA0_16BIT_SetDuty
//  : }ֵ
// ע     : ռձ : TMRA0PWM0(LSB)/TMRA0PWM1(MSB)  (16λԪģʽ)               
//*********************************************************************
void TMRA0_16BIT_SetDuty(uint duty)
{    
	TMRA0PWM0     = (duty & 0xFF);
	TMRA0PWM1     = ((duty & 0xFF00)>>8);
}

//*********************************************************************
//    : TMRA00_16BIT_SetPeriod
//  : Lڼֵ
// ע     : TMRA0DR0(LSB)/TMRA0DR1(MSB) (16λԪģʽ)
//*********************************************************************
void TMRA0_16BIT_SetPeriod(uint period)
{
    TMRA0DR0     = (period & 0xFF);
	TMRA0DR1     = ((period & 0xFF00)>>8);
}

//*********************************************************************
//    : TMRA0_SetPrescale
//  : Lڼֵ
// ע     : ռձ 50%
//*********************************************************************
void TMRA0_SetPrescale(uchar duty)
{   
   	TMRA0PWM0    = duty;                // 趨 Prescale ռձֵ(Duty)
  	if((duty*2)>255)                    // 趨 Prescale Lֵ(Cycle)
		TMRA0DR0 = 255;
	else
		TMRA0DR0 = (duty*2);
}

//*********************************************************************
//    : TMRA00_Start
//  : TMRA00
// ע     :
//*********************************************************************
void TMRA00_Start(void)
{
    TMRA0CR0_RUN   = 1;                // ʱTimmer00
}

//*********************************************************************
//    : TMRA01_Start
//  : (TMRA01)  (16BIT TMRA0)
// ע     :
//*********************************************************************
void TMRA01_Start(void)
{
    TMRA0CR1_RUN   = 1;                // ʱTimmer01
}

//*********************************************************************
//    :TMRA00_Stop
//  : ֹͣTMRA00
// ע     :
//*********************************************************************
void TMRA00_Stop(void)
{
    TMRA0CR0_RUN   = 0;                // ֹͣʱTimmer00
}

//*********************************************************************
//    :TMRA01_Stop
//  : ֹͣ(TMRA01)  (16BIT TMRA0)
// ע     :
//*********************************************************************
void TMRA01_Stop(void)
{
    TMRA0CR1_RUN   = 0;                // ֹͣʱTimmer01
}
//*********************************************************************
//    : TMRA00_IntEnable
//  : TMRA00ж
// ע     : ִкῪж(IMF)
//*********************************************************************
void TMRA00_IntEnable(void)
{
    DI;                                 // ֹпж // EIRL_IMF=0
    IFR_TMRA00_IRQ = 0;                 // ж
    IER_TMRA00_IRQ = 1;                 // 趨ж
    EI;                                 // пж // EIRL_IMF=1
}


//*********************************************************************
//    : TMRA01_IntEnable
//  : (TMRA01)  (16BIT TMRA0) ж
// ע     : ִкῪж(IMF)
//*********************************************************************
void TMRA01_IntEnable(void)
{
    DI;                                 // ֹпж // EIRL_IMF=0
    IFR_TMRA01_IRQ = 0;                 // ж
    IER_TMRA01_IRQ = 1;                 // 趨ж
    EI;                                 // пж // EIRL_IMF=1
}


//*********************************************************************
//    : TMRA00_IntDisable
//  : ֹTMRA00ж
// ע     : ִкῪж(IMF)
//*********************************************************************
void TMRA00_IntDisable(void)
{
    DI;                                 // ֹпж // EIRL_IMF=0
    IER_TMRA00_IRQ = 0;                 // ж
	IFR_TMRA00_IRQ = 0;                 // ж
    EI;                                 // пж // EIRL_IMF=1
}

//*********************************************************************
//    : TMRA01_IntDisable
//  : ֹ(TMRA01)  (16BIT TMRA0)ж
// ע     : ִкῪж(IMF)
//*********************************************************************
void TMRA01_IntDisable(void)
{
    DI;                                 // ֹпж // EIRL_IMF=0
    IER_TMRA01_IRQ = 0;                 // ж
	IFR_TMRA01_IRQ = 0;                 // ж
    EI;                                 // пж // EIRL_IMF=1
}

//*********************************************************************
//    : TMRA00_IRQ
//  : жϸʽ
// ע     :
//*********************************************************************
void __interrupt TMRA00_IRQ(void)
{
    //P9DR_P0 = !P9DR_P0;			    // 趨P90
	LED1_out = ~ LED1_out;              // 趨LED1_out
    NOP;                                // ָ
}

//*********************************************************************
//    : TMRA01_IRQ
//  : жϸʽ
// ע     :
//*********************************************************************
void __interrupt TMRA01_IRQ(void)
{
    //P9DR_P0 = !P9DR_P0;				// 趨P90
	LED1_out = ~ LED1_out;              // 趨LED1_out
    NOP;                                // ָ
}


//*********************************************************************
//    : TMRA10_PPG_Init
//  : TMRA10 8λPPGģʽL16.7usռձ50%
// ע     :
//*********************************************************************
void TMRA10_PPG_Init(void)
{
//====== ܽųʼ ======
    P0DO_P3         = 1;                // ܽʼ P03ߵƽ  **ͬ PPG ĳʼֵ(TMRAxMOD_TFF)
    P0OE_P3         = 1;                // P03ܽ趨Ϊ

//====== ܿ( Enable) ======
    PCKEN0_TMRA1    = 1;                // ȿݴò

//====== 趨 ======
    TMRA1CFG_TCFG   = set_8bit;         // 趨Ϊ 8 bit ģʽ
    TMRA1MD0_TCM    = PPG;              // 趨Ϊ 8 λɱ PPG ģʽ
	
    TMRA1MD0_TFF    = 1;                // 趨ʼֵΪ"׼λ"ռձ
//	***PxFC ùţڳʼֵ趨֮ PxFC
    P0CFGCR         = 0xB1;             // лP03Ϊ⹦ܽ,ܽ趨Ϊ PPG 
    
    TMRA1MD0_TCK    = 5;                // fcgck/4 = 6MHz = 0.167us
    TMRA1MD0_DBE    = 1;                // ʹ˫

    TMRA1DR0        = 100;              // 趨 PPG  = 100*0.167us =16.7us(PPG=TMRA1DR0*TMRA1MD0_TCK)
    TMRA1PWM0       = 50;               // 趨 PPG ռձ = 50/100 = 50%
}

//*********************************************************************
//    : TMRA10_Start
//  : TMRA10
// ע     :
//*********************************************************************
void TMRA10_Start(void)
{
    TMRA1CR0_RUN   = 1;                // ʱTimmer10
}

//*********************************************************************
//    :TMRA10_Stop
//  : ֹͣTMRA10
// ע     :
//*********************************************************************
void TMRA10_Stop(void)
{
    TMRA1CR0_RUN   = 0;                // ֹͣʱTimmer10
}